
/*
xpequ copyright (c) 2007-always Jan Panteltje

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "forms.h"
#include <stdlib.h>
#include "xpequ.h"


//void one_second_tick(int sig);


FD_xpequ *fdui;
char *mydata;

FD_xpequ *create_form_xpequ(void)
{
FL_OBJECT *obj;
fdui = (FD_xpequ *) fl_calloc(1, sizeof(*fdui));

fl_set_idle_callback(idle_cb, 0);

fdui -> xpequ = fl_bgn_form(FL_NO_BOX, 600, 300);

obj = fl_add_box(FL_UP_BOX, 0, 0, 600, 300, "");

fdui -> equalizer_control0_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 20, 10, 30, 100, "30 Hz");
	fl_set_object_callback(obj, equalizer_control0_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control1_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 60, 10, 30, 100, "60 Hz");
	fl_set_object_callback(obj, equalizer_control1_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control2_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 100, 10, 30, 100, "125 Hz");
	fl_set_object_callback(obj, equalizer_control2_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control3_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 140, 10, 30, 100, "250 Hz");
	fl_set_object_callback(obj, equalizer_control3_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control4_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 180, 10, 30, 100, "500 Hz");
	fl_set_object_callback(obj, equalizer_control4_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control5_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 220, 10, 30, 100, "1000 Hz");
	fl_set_object_callback(obj, equalizer_control5_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control6_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 260, 10, 30, 100, "2000 Hz");
	fl_set_object_callback(obj, equalizer_control6_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control7_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 300, 10, 30, 100, "4000 Hz");
	fl_set_object_callback(obj, equalizer_control7_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control8_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 340, 10, 30, 100, "8000 Hz");
	fl_set_object_callback(obj, equalizer_control8_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> equalizer_control9_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 380, 10, 30, 100, "16000 Hz");
	fl_set_object_callback(obj, equalizer_control9_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, EQUALIZER_RANGE, -EQUALIZER_RANGE);
	fl_set_slider_value(obj, 0);

fdui -> fft_log_x_axis_group =  fl_bgn_group();
/*
fdui -> fft_log_x_axis_2_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 40, 250, 30, 10, "2.2");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT | FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj, FL_TINY_SIZE); 
*/
	 
fdui -> fft_log_x_axis_22_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 50, 250, 30, 10, "22");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT | FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj, FL_TINY_SIZE); 
	 
fdui -> fft_log_x_axis_220_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 135, 250, 30, 10, "220");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT | FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj, FL_TINY_SIZE); 
	 
fdui -> fft_log_x_axis_2200_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 260, 250, 30, 10, "2200");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT | FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj, FL_TINY_SIZE); 
	 
fdui -> fft_log_x_axis_22k_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 390, 250, 30, 10, "22k");
	fl_set_object_lalign(obj,FL_ALIGN_LEFT | FL_ALIGN_INSIDE);
	fl_set_object_lsize(obj, FL_TINY_SIZE); 
fl_end_group();
	 
fdui -> main_form_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 420, 280, 150, 15, "Panteltje (c) xpequ");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);

fdui -> non_equalizer_group = fl_bgn_group();
fdui -> fft_display = obj =\
	fl_add_xyplot(FL_IMPULSE_XYPLOT, 20, 150, 390, 100, "FFT");
	fl_set_object_boxtype(obj, FL_DOWN_BOX);
	fl_set_object_color(obj, FL_BLACK, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_INSIDE);
	fl_set_object_callback(obj, fft_display_cb, 0);

fdui -> scope_display = obj =\
	fl_add_xyplot(FL_NORMAL_XYPLOT, 20, 150, 390, 100, "SCOPE");
	fl_set_object_boxtype(obj, FL_DOWN_BOX);
	fl_set_object_color(obj, FL_BLACK, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_INSIDE);
	fl_set_object_callback(obj, scope_display_cb, 0);

/*
fdui -> scope_display_grid_overlay = obj =\
	fl_add_xyplot(FL_NORMAL_XYPLOT, 20, 150, 390, 100, "SCOPE");
	fl_set_object_boxtype(obj, FL_DOWN_BOX);
	fl_set_object_color(obj, FL_BLACK, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_INSIDE);
	fl_set_object_callback(obj, scope_display_cb, 0);

*/

fdui->threshold_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 550, 10, 30, 100, "threshold");
	fl_set_object_callback(obj, threshold_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 0, -100);
	fl_set_slider_value(obj, 50);

fdui -> level_enabled_output_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 550, 125, 30, 15, "VOX");
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_object_callback(obj, level_enabled_output_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> audio_peak_indicator_slider = obj =\
	fl_add_valslider(FL_VERT_FILL_SLIDER, 510, 10, 30, 100, "peak audio");
	fl_set_object_callback(obj, audio_peak_indicator_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 0, -100);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_slider_value(obj, 50);

fdui -> agc_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 510, 125, 30, 15, "AGC");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, agc_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> color_output_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 470, 150, 30, 15, "col");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, color_output_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> serial_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 510, 150, 80, 15, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_object_callback(obj, serial_device_select_button_cb, 0);

fdui->on_time_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 430, 10, 30, 100, "on ms");
	fl_set_object_callback(obj, on_time_slider_cb, 0);
	fl_set_slider_precision(obj, 1);
	fl_set_slider_bounds(obj, 10, 1);
	fl_set_slider_value(obj, 1.5);

fdui->off_time_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 470, 10, 30, 100, "off ms");
	fl_set_object_callback(obj, off_time_slider_cb, 0);
	fl_set_slider_precision(obj, 0);
	fl_set_slider_bounds(obj, 4000, 100);
	fl_set_slider_value(obj, 1000);

fdui -> equalizer_enable_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 380, 125, 30, 15, "eq");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, equalizer_enable_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> audio_mode_select_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 560, 255, 30, 15, "alsa");
	fl_set_object_color(obj, FL_COL1, FL_MAGENTA);
	fl_set_object_callback(obj, audio_mode_select_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	
fdui -> display_mode_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 380, 260, 30, 15, "");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, display_mode_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> fft_log_scale_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 340, 265, 30, 15, "log");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, fft_log_scale_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> scope_speed_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 305, 265, 15, 15, "+");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_speed_up_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> scope_speed_text = obj =\
    fl_add_text(FL_NORMAL_TEXT, 325, 265, 20, 15, "");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_object_color(obj, FL_CYAN, FL_CYAN);
	
fdui -> scope_speed_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 350, 265, 15, 15, "-");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_speed_down_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> scope_trigger_mode_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 275, 265, 15, 15, "+");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_trigger_mode_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> scope_trigger_level_slider = obj = \
	fl_add_valslider(FL_HOR_BROWSER_SLIDER, 170, 265, 100, 15, "trigger level");
	fl_set_object_callback(obj, scope_trigger_level_slider_cb, 0);
	fl_set_slider_precision(obj, 2);
	fl_set_slider_bounds(obj, -1.0, +1.0);
	fl_set_slider_value(obj, 1);
	fl_set_object_color(obj, FL_CYAN, FL_DARKVIOLET);

fdui -> scope_timebase_text = obj =\
    fl_add_text(FL_NORMAL_TEXT, 305, 280, 60, 15, "timebase");
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> scope_auto_trigger_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 135, 265, 30, 15, "auto");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_auto_trigger_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> scope_sensitivity_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 105, 265, 15, 15, "-");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_sensitivity_up_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> scope_sensitivity_text = obj =\
    fl_add_text(FL_NORMAL_TEXT, 70, 265, 30, 15, "");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_object_color(obj, FL_CYAN, FL_CYAN);

fdui -> scope_sensitivity_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 50, 265, 15, 15, "+");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, scope_sensitivity_down_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> scope_sensitivity_label_text = obj =\
    fl_add_text(FL_NORMAL_TEXT, 50, 280, 70, 15, "Volts fullscale");
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> off_time_x10_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 470, 125, 30, 15, "x10");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, off_time_x10_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
                
fdui -> filename_indicator = obj =\
	fl_add_box(FL_FRAME_BOX, 20, 125, 350, 15, "");
	fl_set_object_lalign(obj, FL_ALIGN_INSIDE);	
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	fl_set_object_color(obj, FL_BLUE, FL_BLUE);
	fl_set_object_lcolor(obj, FL_WHITE);
	                
fdui -> internet_server_name_indicator = obj =\
	fl_add_box(FL_FRAME_BOX, 460, 150, 130, 20, "");
	fl_set_object_lalign(obj, FL_ALIGN_INSIDE);	
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	
fdui -> internet_stream_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 470, 175, 30, 15, "stream");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, internet_stream_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> audio_input_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 540, 185, 50, 15, "");
	fl_set_object_callback(obj, audio_input_device_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
 
fdui -> audio_input_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 540, 200, 50, 15, "input");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> audio_output_device_select_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 540, 220, 50, 15, "");
	fl_set_object_callback(obj, audio_output_device_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	 
fdui -> audio_output_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 540, 235, 50, 15, "output");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);	
fl_end_group();

fdui -> equalizer_gain_slider = obj =\
	fl_add_valslider(FL_VERT_BROWSER_SLIDER, 420, 150, 30, 100, "eq gain");
	fl_set_object_callback(obj, equalizer_gain_slider_cb, 0);
	fl_set_slider_precision(obj, 2);
	fl_set_slider_bounds(obj, 2, 0);
	fl_set_slider_value(obj, 1);

fdui -> audio_control_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 460, 230, 30, 15, "audio");
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, audio_control_button_cb, 0);
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	
fdui -> channels_indicator = obj =\
	fl_add_box(FL_FRAME_BOX, 501, 255, 30, 15, "");
	fl_set_object_lalign(obj, FL_ALIGN_INSIDE);	
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	
fdui -> sample_speed_indicator = obj =\
	fl_add_box(FL_FRAME_BOX, 460, 255, 40, 15, "");
	fl_set_object_lalign(obj, FL_ALIGN_INSIDE);	
	fl_set_object_lsize(obj, FL_TINY_SIZE);
	
fdui -> exit_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 260, 20, 20, "E");
	fl_set_object_callback(obj, exit_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
//	fl_set_object_lsize(obj, FL_TINY_SIZE);

fl_add_signal_callback(\
    SIGALRM, (FL_SIGNAL_HANDLER)one_second_tick, NULL); //&mydata);
alarm(1);

fl_end_form();

fdui -> xpequ -> fdui = fdui;

return fdui;
} /* end function create_form_xpequ */



